#!/bin/sh

cd `dirname $0`

. ./commun-minfetchmail

[ -z "$TimeOut" ] && TimeOut=30 # Timeout de 30 sec
[ -z "$Buff" ] && Buff=5 # Entre chaque command passer au serveur POP

Quitter ()
{
    rm -f $FicTemp $FicTemp.stats
    exit
}

trap Quitter  0 2 3 6 9

while [ -n "$1" ]
do
    case "$1" in
        -k) Keep="y" ;;
        -c) Confirm="y" ;;
        -s) Verbose=y ; Stats="y" ;;
        -q) rm -f $FicTemp ; exit 0 ;;
        -f) if [ -n "$2" ]
            then
                ln -sf $2 ./commun-minfetchmail
                . ./commun-minfetchmail
            else
               `basename $0` -h
                exit 1
            fi
            shift
            ;;
        -h) echo "Usage : `basename $0` [ -k | -c | -q | -f <fic conf> | -v | -s ]" && exit 0 ;;
        -v) Verbose="y" ;;
        *) echo >&2 "Option non connue : $1" ; $0 -h ;;
    esac
    shift
done

[ -z "$POP_HOST" ] && POP_HOST=localhost
[ -z "$POP_PORT" ] && POP_PORT=110
[ -z "$POP_USERNAME" ] && POP_USERNAME=$LOGNAME
if [ -z "$POP_PASSWORD" ]
then
    echo -n "$POP_USERNAME@$POP_HOST's password: "
    stty -echo
    read POP_PASSWORD
    stty echo
    echo
fi

[ -z "$MAILBOX" ] && MAILBOX=$HOME/Inbox

if [ -f $FicTemp ]
then
    echo >&2 "Fichier de lock existe. Essayer $0 -q"
    exit 1
else
    touch $FicTemp
fi

(
echo "USER $POP_USERNAME"
sleep $Buff
echo "PASS $POP_PASSWORD"
sleep $Buff
echo "STAT"
sleep $Buff
echo "LIST"
sleep $Buff
echo "QUIT"
sleep $Buff
) | nc -w $TimeOut $POP_HOST $POP_PORT > $FicTemp || Quitter

[ -n "$Verbose" ] && cat $FicTemp

if [ -n "$Stats" ]
then
    echo "Continuer ([o]/n) ?"
    read reponse
    case "$reponse" in
        ""|o*|O*|y*|Y*) ;;
        *) Quitter ;;
    esac
fi

NombreMessages=`sed -n "4p" < $FicTemp | cut -d " " -f2`

sed -n "6,`expr 5 + $NombreMessages`p" < $FicTemp > $FicTemp.stats

unset LANG
i=1
NoMessage=1

while [ $i -le $NombreMessages ]
do

    Delete=""

    if [ "$Confirm" = "y" ]
    then
(
echo "USER $POP_USERNAME"
sleep $Buff
echo "PASS $POP_PASSWORD"
sleep $Buff
echo "TOP $NoMessage 1"
sleep $Buff
echo "QUIT"
sleep $Buff
) | nc -w $TimeOut $POP_HOST $POP_PORT > $FicTemp

        egrep "^From: |^To: |^Subject: " $FicTemp
        cat << EOF
Size (ko): `cat $FicTemp.stats | sed -n "${i}p" | sed "s/^[0-9][0-9]* *//"`

Effacer ce message (o/[n]) ?
EOF
        read reponse
        case "$reponse" in
            o*|O*|y*|Y*)
#        (
#echo "USER $POP_USERNAME"
#sleep $Buff
#echo "PASS $POP_PASSWORD"
#sleep $Buff
#echo "DELE 1"
#sleep $Buff
#echo "QUIT"
#sleep $Buff
#) | nc -w $TimeOut $POP_HOST $POP_PORT > $FicTemp
        Delete="y"
#        [ -n "$Verbose" ] && echo "Message $i elimine"
               ;;
            *) ;; # NO !
        esac
    fi
   
    if [ "$Delete" != "y" ]
    then
        echo "From $LOGNAME `date`" >> $MAILBOX
        (
    echo "USER $POP_USERNAME"
    sleep $Buff
    echo "PASS $POP_PASSWORD"
    sleep $Buff
    echo "RETR $NoMessage"
    sleep $Buff
    echo "QUIT"
    sleep $Buff
    ) | nc -w $TimeOut $POP_HOST $POP_PORT > $FicTemp
        NombreLignes=`cat $FicTemp | wc -l`
        [ -n "$Verbose" ] && echo "$i $NombreLignes" && egrep "^From: |^To: |^Subject: " $FicTemp
        head -n `expr $NombreLignes - 3` < $FicTemp | grep -v "^+OK" | tr -d '\015' >> $MAILBOX
        echo >> $MAILBOX
    fi
    
        if [ "$Keep" != "y" -o "$Delete" = "y" ]
        then
            (
    echo "USER $POP_USERNAME"
    sleep $Buff
    echo "PASS $POP_PASSWORD"
    sleep $Buff
    echo "DELE 1"
    sleep $Buff
    echo "QUIT"
    sleep $Buff
    ) | nc -w $TimeOut $POP_HOST $POP_PORT > $FicTemp
            [ -n "$Verbose" ] && echo "Message $i elimine"
            NoMessage=1
        else
            [ -n "$Verbose" ] && echo "Message $NoMessage non elimine"
            NoMessage=`expr $i + 1`
        fi
        [ -n "$Verbose" ] && echo
    i=`expr $i + 1`
done

rm -f $FicTemp $FicTemp.stats

