#!/bin/sh

Pwd=`pwd`
cd `dirname $0`
[ -L $0 ] && cd `dirname \`ls -l $0 | sed "s/.* -> //"\``

[ -f ./commun-minfetchmail ] && . ./commun-minfetchmail

[ -z "$TimeOut" ] && TimeOut=30 # Timeout de 30 sec
[ -z "$Buff" ] && Buff=5 # Entre chaque command passer au serveur POP

Quitter ()
{
    echo
    [ -f $FicTemp ] && grep "^-ERR " $FicTemp
    rm -f $FicTemp /tmp/pop-cmd
    exit
}

trap Quitter  0 2 3 6 9

while [ -n "$1" ]
do
    case "$1" in
        -k) Keep="y" ;;
        -c) Confirm="y" ;;
        -s) Verbose=y ; Stats="y" ;;
        -q) rm -f $FicTemp ; exit 0 ;;
        -f) if [ -n "$2" ]
            then
                echo "$2" | grep "^/" > /dev/null && FicConf="$2" || FicConf="$Pwd/$2"
                ln -sf $FicConf ./commun-minfetchmail
                #ln -sf $2 ./commun-minfetchmail
                . ./commun-minfetchmail
            else
               `basename $0` -h
                exit 1
            fi
            shift
            ;;
        -h) echo "Usage : `basename $0` [ -k | -c | -q | -f <fic conf> | -v | -s ]" && exit 0 ;;
        -v) Verbose="y" ;;
        *) echo >&2 "Option non connue : $1" ; $0 -h ;;
    esac
    shift
done

[ -z "$POP_HOST" ] && POP_HOST=localhost
[ -z "$POP_PORT" ] && POP_PORT=110
[ -z "$POP_USERNAME" ] && POP_USERNAME=$LOGNAME
if [ -z "$POP_PASSWORD" ]
then
    echo -n "$POP_USERNAME@$POP_HOST's password: "
    stty -echo
    read POP_PASSWORD
    stty echo
    echo
fi

[ -z "$MAILBOX" ] && MAILBOX=$HOME/Inbox

if [ -f $FicTemp ]
then
    echo >&2 "Fichier de lock existe. Essayer $0 -q"
    exit 1
else
    touch $FicTemp
fi

(
echo "USER $POP_USERNAME"
sleep $Buff
echo "PASS $POP_PASSWORD"
sleep $Buff
echo "STAT"
sleep $Buff
echo "LIST"
sleep $Buff
echo "QUIT"
sleep $Buff
) | nc -w $TimeOut $POP_HOST $POP_PORT > $FicTemp || Quitter

grep "^-ERR " $FicTemp > /dev/null && Quitter

NombreMessages=`sed -n "4p" < $FicTemp | cut -d " " -f2`

[ -n "$Verbose" ] && cat $FicTemp
ListeTailles=`egrep -v "^\+|^\." $FicTemp | tr -d '\r'`
TailleTotale=`grep "^+OK $NombreMessages [0-9][0-9]*" $FicTemp | cut -d " " -f3 | tr -d '\r'`

if [ -n "$Stats" ]
then
    cat $FicTemp
    echo "Continuer ([o]/n) ?"
    read reponse
    case "$reponse" in
        ""|o*|O*|y*|Y*) ;;
        *) Quitter ;;
    esac
fi

#sed -n "6,`expr 5 + $NombreMessages`p" < $FicTemp > $FicTemp.stats

unset LANG # Pour que la commande date affiche la date en anglais
i=1
NoMessage=1

(
echo "USER $POP_USERNAME"
sleep $Buff
echo "PASS $POP_PASSWORD"
sleep $Buff

[ -z "$NombreMessages" ] && Quitter
while [ $i -le $NombreMessages ]
do
    Delete=""

        echo "TOP $i 1"
        sleep $Buff
    i=`expr $i + 1`
done
echo "QUIT"
sleep $Buff
) | nc -w $TimeOut $POP_HOST $POP_PORT > $FicTemp || Quitter

i=1
IFS='
'
ConfirmDelete ()
{
    Message=`expr $i - 1`
    echo
    echo -n "Effacer ce message (o/[n]) ? "
    read reponse
    case "$reponse" in
        o*|O*|y*|Y*) echo "DELE $Message" >> /tmp/pop-cmd ;;
        *) echo -e "LIST $Message\nRETR $Message" >> /tmp/pop-cmd
           [ "$Keep" != "y" ] && echo "DELE $Message" >> /tmp/pop-cmd
           ;;
    esac
}

: > /tmp/pop-cmd
chmod 600 /tmp/pop-cmd # Le pass du serveur POP est dans ce fichier

cat << EOF > /tmp/pop-cmd
USER $POP_USERNAME
PASS $POP_PASSWORD
EOF

for ligne in `cat $FicTemp`
do
    if echo "$ligne" | grep "^+OK [0-9][0-9]* octets" > /dev/null
    then
        if [ "$Confirm" = "y" ]
        then
            [ $i -ne 1 ] && ConfirmDelete
        else
            echo -e "LIST $i\nRETR $i" >> /tmp/pop-cmd
            [ "$Keep" != "y" ] && echo "DELE $i" >> /tmp/pop-cmd
        fi
        if [ -n "$Verbose" ] || [ "$Confirm" = "y" ]
        then
            echo
            echo "[$i] $ligne"
        fi
        i=`expr $i + 1`
    fi
    [ -n "$Verbose" ] || [ "$Confirm" = "y" ] && echo "$ligne" | egrep "^From: |^To: |^Subject: "
done

chmod 600 /tmp/pop-cmd # Le pass du serveur POP est dans ce fichier

[ "$Confirm" = "y" ] && [ $i -ne 1 ] && ConfirmDelete

echo "QUIT" >> /tmp/pop-cmd

echo
echo "OK, starting now..."

if [ "$MinProcmail" = "y" ]
then
    MAILBOX=/tmp/$LOGNAME-mail.$$
    rm -f $MAILBOX
fi

set -- $ListeTailles
TailleRecue=0
cat /tmp/pop-cmd | while read ligne
do
    echo "$ligne"
    if [ "$Verbose" = "y" ] && echo "$ligne" | grep "^RETR " > /dev/null
    then
        N=`echo "$ligne" | cut -d " " -f2`
        TailleMessage=`echo $1 | cut -d " " -f2`
        TailleRecue=`expr $TailleRecue + $TailleMessage`
        Pct=`expr $TailleRecue \* 100 / $TailleTotale`
        echo "$N/$NombreMessages ($TailleMessage octets) $Pct % done." >&2
        shift
    fi
    sleep $Buff
done | nc -w $TimeOut $POP_HOST $POP_PORT | sed \
        -e "s/^+OK [0-9][0-9]* [0-9][0-9]*/From $LOGNAME `date`/" \
        -e "/^+OK /d" \
        -e "s/^\.//" \
   >> $MAILBOX

    if [ "$MinProcmail" = "y" ]
    then
        #mv -f $MAILBOX /tmp/$LOGNAME-mail.$$
        [ "$Verbose" = "y" ] && ./minprocmail.sh -v < $MAILBOX || ./minprocmail.sh < $MAILBOX
        [ $? -eq 0 ] && rm -f $MAILBOX
    fi

Quitter

